import { AggregateRoot, AggregateID } from '@mobicoop/ddd-library';
import { v4 } from 'uuid';
import { CreateMatchProps, MatchProps } from './match.types';

export class MatchEntity extends AggregateRoot<MatchProps> {
  protected readonly _id: AggregateID;

  static create = (create: CreateMatchProps): MatchEntity => {
    const id = v4();
    const props: MatchProps = { ...create };
    return new MatchEntity({ id, props });
  };

  validate(): void {
    // entity business rules validation to protect it's invariant before saving entity to a database
  }
}
